﻿Type=Class
Version=3.8
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private mAct As Activity
	Private WebView1 As WebView
	Private WVE As WebViewExtras
	Private mSongCount As Int
	Private JSDomain As String = "javascript:"
	Private mModule As Object
	Private Loaded,Loading As Boolean
	Private SU As StringUtils
	Private BC As ByteConverter
	
	End Sub
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Act As Activity,Module As Object,Refresh As Boolean)
	mAct = Act
	mModule = Module
	mAct.LoadLayout("WebView")
	
	'Used to enable javascript error logging
	WVE.addWebChromeClient(WebView1,"")
	'Set the callback for returning values
	WVE.addJavascriptInterface(WebView1,"B4aSongs")
	WebView1.JavaScriptEnabled = True
'	Dim WVJO As JavaObject = WebView1
'	WVJO.RunMethod("setInitialScale",Array As Object(75))
	WebView1.LoadHtml(BuildHTML)
	'Turn on the Webview if we are refreshing after a restart as we can't do it in the Show sub in this case.
	If Refresh Then WebView1.Visible = True
End Sub
Sub Show(index As String,Refresh As Boolean)
	
	'Setup the string for the javascript call
	Dim ParserParams As String = "{}"
	Dim PrinterParams As String = "{}"
	Dim RenderParams As String = "{}"
	
	'Call the javascript sub to handle the display
	Dim JSSString As String = "showSong(" & index & "," & ParserParams & "," & PrinterParams & "," & RenderParams & ")"
	CallJavaScript(WebView1,JSSString)
	
	'We cant call this if refresh is in effect as it is being run on a thread provided by WebViewExtras, it is done in initialize instead
	If Not(Refresh) Then WebView1.Visible = True
End Sub
Sub Hide
	WebView1.Visible = False
End Sub
Private Sub WebView1_PageFinished (Url As String)

	If SubExists(mModule,"WebViewReady") Then CallSub(mModule,"WebViewReady")
End Sub
Private Sub BuildHTML As String

	Dim HTML As StringBuilder
	HTML.Initialize
	HTML.Append("<!DOCTYPE HTML>" & CRLF)
	HTML.Append("<html>" & CRLF)
	HTML.Append("<head>" & CRLF)
	
	'Set the size of the view to the device width and the initial scaling to 0.75
	HTML.Append("<meta name=""viewport"" content=""width=device-width,initial-scale=0.75,minimum-scale=0.5, maximum-scale=5.0"">" & CRLF)
	
	'Load the Javascript libraries
	'ABC library
	HTML.Append("<script src=""" & WebViewAssetFile("abcjs_basic_1.10-min.js") & """ type=""text/javascript""></script>" & CRLF)
	'Base64 encoding/decoding library
	HTML.Append("<script src=""" & WebViewAssetFile("base64v1_0.js") & """ type=""text/javascript""></script>" & CRLF)
	
	'JavaScript functions
	HTML.Append("<script charset='UTF-8'>" & CRLF)
	
	'Global variable for the songbook
	HTML.Append("var book;" & CRLF)
	
	'Load a songbook
	HTML.Append("function loadFile(filedata){" & CRLF)
	HTML.Append("    filedata = B64.decode(filedata);" & CRLF)	
	'HTML.Append("   console.log(filedata);" & CRLF)
	HTML.Append("    book = new ABCJS.TuneBook(filedata);" & CRLF)
	HTML.Append("    B4aSongs.CallSub('JSCallback',false,'loadfile','');" & CRLF)
	HTML.Append("}" & CRLF)
	
	'Get the number of songs
	HTML.Append("function getSongCount(){" & CRLF)
	HTML.Append("B4aSongs.CallSub('JSCallback',false,'songcount',book.tunes.length);" & CRLF)
	HTML.Append("}" & CRLF)
	
	'Get a list of the songs delimieted by Char(254)
	HTML.Append("function getSongList(){" & CRLF)
	HTML.Append("var numberOfTunes = book.tunes.length;" & CRLF)
	HTML.Append("var rtnStr = '';" & CRLF)
	HTML.Append("for (var i = 0; i < numberOfTunes; i++) {" & CRLF)
	'HTML.Append("console.log(i + ': ' + book.tunes[i].title);" & CRLF)
	HTML.Append("    rtnStr = rtnStr + book.tunes[i].title;" & CRLF)
	HTML.Append("    if (i < numberOfTunes - 1){" & CRLF)
	HTML.Append("        rtnStr = rtnStr + String.fromCharCode(254);" & CRLF) 
	HTML.Append("    }" & CRLF)
	HTML.Append("}" & CRLF)
	HTML.Append("B4aSongs.CallSub('JSCallback',true,'songlist',rtnStr);" & CRLF)
	HTML.Append("}" & CRLF)
	
	'Show the chosen song, chosen by it's list index
	HTML.Append("function showSong(index,parserParams,printerParams,renderParams){" & CRLF)
	'HTML.Append("console.log(index)" & CRLF)
	HTML.Append("	ABCJS.renderAbc('notation',book.tunes[index].abc,parserParams,printerParams,renderParams);" & CRLF)
	HTML.Append("}" & CRLF)
	
	HTML.Append("</script>" & CRLF)
	'End of JavaScript functions
	
	HTML.Append("</head>" & CRLF)
	'Set up the div that the song will be rendered into
	HTML.Append("<div id='notation'></div>" & CRLF)
	HTML.Append("</body>" & CRLF)
	HTML.Append("</html>" & CRLF)
	Return HTML.ToString
End Sub
Sub getVisible As Boolean
	Return WebView1.Visible
End Sub
'Javascript injection to call JS functions
Private Sub CallJavaScript(WV As WebView,JSString As String)
	WV.LoadUrl(JSDomain & JSString)
End Sub
'Get the number of songs in the loaded file, returns -1 if a file is not currently loaded
Sub getSongCount As Int
	If Loaded Then
		Return mSongCount
	Else 
		Return -1
	End If
End Sub
'JS Calls
Sub Load(FilePath As String,FileName As String)
	Loaded = False
	Loading = True
	Dim FileData As String = File.ReadString(FilePath,FileName)
	Dim FileArr() As Byte = BC.StringToBytes(FileData,"UTF-8")
	Dim JSString As String = "loadFile(""" &SU.EncodeBase64(FileArr) & """)"
	CallJavaScript(WebView1,JSString)
End Sub

'JS return value subs
Private Sub JSCallBack(Id As String,Val As String)

	'Chain the Javascript calls we need to initialize the songbook
	If Id = "loadfile" Then
		Dim JSString As String = "getSongList()"
		CallJavaScript(WebView1,JSString)
		Return
	End If
	
	If Id = "songlist" Then
		Log(Val)
		CallSub2(mModule,"UpdateList",Val)
		Dim JSString As String = "getSongCount()"
		CallJavaScript(WebView1,JSString)
		Return
	End If

	'Last of the setups call LoadComplete if we are loading the song
	If Id = "songcount" Then
		mSongCount = Val
		If Loading Then 
			Loading = False
			Loaded = True
			If SubExists(mModule,"LoadComplete") Then CallSub(mModule,"LoadComplete")
		End If
		Return
	End If
	

End Sub
'Erel's code to select the correct asset directory from here: http://www.basic4ppc.com/android/forum/threads/images-loaded-in-webviews-are-not-displayed-in-mode-%E2%80%9Cdebug-rapid-%E2%80%9D-b4a-3-50-version.38981/#post-230988
Private Sub WebViewAssetFile (FileName As String) As String
	Dim jo As JavaObject
	jo.InitializeStatic("anywheresoftware.b4a.objects.streams.File")
	If jo.GetField("virtualAssetsFolder") = Null Then
		Return "file:///android_asset/" & FileName.ToLowerCase
	Else
		Return "file://" & File.Combine(jo.GetField("virtualAssetsFolder"), _
		jo.RunMethod("getUnpackedVirtualAssetFile", Array As Object(FileName)))
	End If
End Sub